// graph.h
#ifndef GRAPH_H
#define GRAPH_H

#include "node.h"
#include <stdlib.h>
#include <stdio.h>
#include <vector>
#include <queue>
#include <list>
#include <string>
#include <iostream>
#include <fstream>
#include <stack>

using namespace std;


class graph 
{
 private:
  	int sourceNodeID;
  	int targetNodeID;
	int forwardCost;
	int backwardCost;

protected:
	vector<node> allNodes ;
	vector<int> forbiddenVector;
public:
	graph();
	~graph();
	graph(int source, int destination, int fCost, int bCost); // creates a graph with source and target node specified. Also specified is the forward and backward cost.

	void buildAdjList(); // build the entire graph.
	void show () ; // dispaly the graph
	int getSize() { return allNodes.size() ; }
	int getSource() { return sourceNodeID ; }
	int getTarget() { return targetNodeID ; }
	void addNode(node nd);
	int getForbiddenNumber() {return forbiddenVector.size();}
	void addForbidden(int k);

	void setForwardCost( int f);

	void setBackWardCost( int b);

	void showForbidden();
	void printForbidden();
	bool runBFS();
	bool runDijkstra();

	void displayParameters();
	void displayResults(ofstream & outputFile, int argCount);
} ;

#endif


