#include "graph.h"
#include "node.h"

using namespace std;

// Global variables

vector<int> gForbiddenVector;
vector<graph> myGraphList;
int forwardCost, backwardCost;
// forward declaration of functions

vector<graph> readInput(ifstream &inputFile, int forwardCost, int backwardCost);

bool isIn(vector<int> forbiddenList, int nodeID);

int main(int argc, char *argv[])
{

	if ( (argc < 3) || (argc > 5) || (argc == 4))
	{
	cout<<"Usage : wheels <inputfilename> <outputfilename>"<<endl;
	cout<< " or"<<endl;
	cout<<"Usage : wheels <inputilename> <outputfilename> <forward cost> <backward cost>"<<endl;
	exit(1);
	}
	if (argc == 5)
	{
		forwardCost = atoi(argv[3]);
		backwardCost = atoi(argv[4]);
	}
	else
	{


		forwardCost =  1;
		backwardCost = 1;
	}



	ifstream inputFile;
	ofstream outputFile ;

if ( argc >= 3)
{
	inputFile.open(argv[1], ios::in);
	if (!inputFile) {
	  cout << "Couldn't open the input file!" << endl;
	  exit(0);
	}
	outputFile.open(argv[2], ios::out);
	if (!outputFile) {
	  cout << "Couldn't open the output file!" << endl;
	  exit(0);
	}
}
else
{


	inputFile.open("input.txt", ios::in);
	if (!inputFile) {
	  cout << "Couldn't open the input file!" << endl;
	  exit(0);
	}
	outputFile.open("output.txt", ios::out);
	if (!outputFile) {
	  cout << "Couldn't open the output file!" << endl;
	  exit(0);
	}
}

	myGraphList = readInput(inputFile, forwardCost, backwardCost);

	int cntr = 0;
	bool success;
	graph tmpGraph;

	while(cntr < myGraphList.size())
	{
		tmpGraph = myGraphList[cntr];
		if (tmpGraph.getSource() == tmpGraph.getTarget()) {
		  outputFile<<"Input # :"<<(cntr+1)<<endl;
		  outputFile << "source and destination matches." << endl;
		  cntr++;
		  continue;
		}
		tmpGraph.buildAdjList() ;
//		tmpGraph.displayParameters();
	if(argc == 3)
		success = tmpGraph.runBFS();
	else
		success = tmpGraph.runDijkstra();

		outputFile<<"Input # :"<<(cntr+1)<<endl;
		if (success)
			tmpGraph.displayResults(outputFile, argc);
		else
		{
		outputFile<<"There is no way to reach from source to destination !!!"<<endl;
		}

		cntr++;
	}
	outputFile.close();
	return 0;
}


bool isIn(vector<int> fb, int k)
{
	vector<int>::iterator i = fb.begin();

	while(i != fb.end())
	{
		if (*i == k) return true;
		i++;
	}
	return false;
}


vector<graph> readInput(ifstream  & infile, int fCost, int bCost)
{
	int numGraphs, cntr = 0, fcntr = 0;
	int source, destination, numForbidden, tmpForbidden;
	int src1,src2,src3,src4,tgt1,tgt2,tgt3,tgt4;
	int fbd1,fbd2,fbd3,fbd4;

	infile>>numGraphs; 

	while(cntr<numGraphs)
	{

		infile>>src1>>src2>>src3>>src4;
		infile>>tgt1>>tgt2>>tgt3>>tgt4;
		source = src1*1000+src2*100+src3*10+src4;
		destination = tgt1*1000+tgt2*100+tgt3*10+tgt4;

		graph myGraph(source, destination, fCost, bCost);

		infile>>numForbidden;
		fcntr = 0;
		while(fcntr<numForbidden)
		{
			infile>>fbd1>>fbd2>>fbd3>>fbd4;
			tmpForbidden = fbd1*1000+fbd2*100+fbd3*10+fbd4;
			myGraph.addForbidden(tmpForbidden);
			fcntr++;
		 }
		// Now add this graph to the vector of graphs.
		myGraphList.push_back(myGraph);
		cntr++;
	}
	return myGraphList;

}


