// Node.cpp

#include "node.h"

bool isIn(vector<int> fb, int k);


// Now let us take up the methods of class node
node::node ()
{
	id = 0 ;
	distance = INT_MAX ;
	parent = -1 ;
	safe = true;	
	active = true;
	color = 0;
}

node::node(int nid)
{
	id = nid ;
	distance = INT_MAX ;
	parent = -1 ;
	safe = true;
	active = true;
	color = 0;
}

int node::getHundreds()
{
	int temp1, temp2;
	temp1 = id- int((id/1000))*1000 ; // gives us last three digits
	temp2 = int(temp1/100) ;// gives us hundreds
	return temp2;
}

int node::getTens()
{
	int ttemp,htemp, tenTemp;
	htemp = id- int((id/1000))*1000; // gives us last three digits
	ttemp = htemp - int(htemp/100)*100;  // gives us last two digits
	tenTemp = int(ttemp/10); // gives us tens
	return tenTemp;
}

int node::getUnits()
{
	int ttemp,htemp, unitTemp;
	htemp = id- int((id/1000))*1000 ; // gives us last three digits
	ttemp = htemp - int(htemp/100)*100 ; // gives us last two digits
	unitTemp = ttemp - int(ttemp/10)*10; // gives us units
	return unitTemp;
}

int node::getNextThousand()
{
	if (getThousands()<9) return id+1000;
	else return id-9000;
}

int node::getPriorThousand()
{
	if (getThousands()>0) return id-1000;
	else return id+9000;
}

int node::getNextHundred()
{
	if (getHundreds()<9) return id+100;
	else return id-900;
}

int node::getPriorHundred()
{
	if (getHundreds()>0) return id-100;
	else return id+900;
}

int node::getNextTen()
{
	if (getTens()<9) return id+10;
	else return id-90;
}

int node::getPriorTen()
{
	if (getTens()>0) return id-10;
	else return id+90;
}

int node::getNextUnit()
{
	if (getUnits()<9) return id+1;
	else return id-9;
}

int node::getPriorUnit()
{
	if (getUnits()>0) return id-1;
	else return id+9;
}


void node::createAdjList(vector<int> fbList, int forwardCost, int backwardCost)
{
	if (!isIn(fbList, getNextThousand())) 
	  {
	    adjList.push_back(getNextThousand());
	    edgeWeight.push_back(forwardCost);
	  }
	if (!isIn(fbList, getPriorThousand())) 
	  {
	    adjList.push_back(getPriorThousand());
	    edgeWeight.push_back(backwardCost);
	  }

	if (!isIn(fbList, getNextHundred())) 	
	  {
	    adjList.push_back(getNextHundred());
	    edgeWeight.push_back(forwardCost);
	  }
	if (!isIn(fbList, getPriorHundred())) 
	  {
	    adjList.push_back(getPriorHundred());
	    edgeWeight.push_back(backwardCost);
	  } 
	if (!isIn(fbList, getNextTen())) 		
	  {
	    adjList.push_back(getNextTen());
	    edgeWeight.push_back(forwardCost);
	  } 
	if (!isIn(fbList, getPriorTen())) 	
	  {
	    adjList.push_back(getPriorTen());
	    edgeWeight.push_back(backwardCost);
	  } 
	if (!isIn(fbList, getNextUnit())) 	
	  {
	    adjList.push_back(getNextUnit());
	    edgeWeight.push_back(forwardCost);
	  } 
	if (!isIn(fbList, getPriorUnit()))  
	  {
	    adjList.push_back(getPriorUnit());
	    edgeWeight.push_back(backwardCost);
	  }
}

void node::show() // show the edgelist related to this node
{
	list<int>:: iterator  lt ;
	for (lt = adjList.begin(); lt!= adjList.end(); lt++)
	{
		cout <<"-->"<<(*lt) ;
	}
}
 
