// Node.h

#ifndef NODE_H

#define NODE_H

#include <list>
#include <vector>
#include <iostream>
#include "limits.h"

using namespace std;

class node
{
friend class graph ;
private:
	int id ;
	int distance ;
	int parent ;
	bool safe ;
	bool active;
	int color; // white = 0, grey = 1 , black = 2
	list<int> adjList;
	list<int>edgeWeight;
	int getNextThousand();
	int getPriorThousand();
	int getNextHundred();
	int getPriorHundred();
	int getNextTen();
	int getPriorTen();
	int getNextUnit();
	int getPriorUnit();
public:
	node() ;
	node (int id) ;
	void setid(int a) { id = a;}
	int getid() { return id; } 
	int getThousands() { return int(id/1000); }
	int getHundreds();
	int getTens();
	int getUnits();
	int getDistance() { return distance ; }
	void setDistance ( int n ) { distance = n; }
	int getParent () { return parent ; }
	void setParent(int n ) { parent = n ; }
	void addEdge( int id) ;
	bool getSafe() { return safe; }
	void setSafe(bool trueFalse) { safe = trueFalse ; }
	void setActive(bool trueOrFalse){active = trueOrFalse;}
	bool getActive() { return active;}
	void createAdjList(vector<int> fb, int forwardCost, int backwardCost);
	void show() ;
	void setColor(int col){color = col;}
	int getAdjListSize(){return adjList.size();}
	int getColor() { return color;}
	list<int> getAdjList(){ return adjList;}
	list<int> getCostAdjList(){return edgeWeight;}
} ;
#endif
